//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%391C5AF200B8.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%391C5AF200B8.cm

//## begin module%391C5AF200B8.cp preserve=no
//## end module%391C5AF200B8.cp

//## Module: LinkExpression%391C5AF200B8; Package specification
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Parse/LinkExpression.h

#ifndef LINKEXPRESSION_H
#define LINKEXPRESSION_H 1

//## begin module%391C5AF200B8.additionalIncludes preserve=no
//## end module%391C5AF200B8.additionalIncludes

//## begin module%391C5AF200B8.includes preserve=yes
//## end module%391C5AF200B8.includes

// Error
#include <XSUtil/Error/Error.h>
// AbstractExpression
#include <XSUtil/Parse/AbstractExpression.h>
//## begin module%391C5AF200B8.declarations preserve=no
//## end module%391C5AF200B8.declarations

//## begin module%391C5AF200B8.additionalDeclarations preserve=yes
#include <xsTypes.h>
#include <list>
#include <utility>
//## end module%391C5AF200B8.additionalDeclarations


//## begin LinkExpression%391B1A15016E.preface preserve=yes
//## end LinkExpression%391B1A15016E.preface

//## Class: LinkExpression%391B1A15016E
//	Concrete subclass of AbstractExpression.  This parses
//	and evaluates mathematical expressions with constraints
//	specific to Xspec's rules of parameter linking, as
//	defined by the newpar command.  Note that this is
//	unaware of Parameter objects as it is at a lower library
//	level.
//## Category: XSUtil::Parse%36939CA6F48B
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class LinkExpression : public AbstractExpression  //## Inherits: <unnamed>%485116C90245
{
  //## begin LinkExpression%391B1A15016E.initialDeclarations preserve=yes
  //## end LinkExpression%391B1A15016E.initialDeclarations

  public:
    //## Class: LinkExpressionError%485118BF03BE
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class LinkExpressionError : public YellowAlert  //## Inherits: <unnamed>%485118DF024F
    {
      public:
        //## Constructors (specified)
          //## Operation: LinkExpressionError%485119340106
          LinkExpressionError (const string& errMsg);

      protected:
      private:
      private: //## implementation
    };

  private:
    //## begin LinkExpression::ElementType%4852C05201BA.preface preserve=yes
    //## end LinkExpression::ElementType%4852C05201BA.preface

    //## Class: ElementType%4852C05201BA; private
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef enum {NUM, PARAM, OPER, LPAREN, RPAREN} ElementType;

    //## begin LinkExpression::ElementType%4852C05201BA.postscript preserve=yes
    //## end LinkExpression::ElementType%4852C05201BA.postscript

  public:
    //## Class: ParamInfo%4857CD360140
    //	Each pair contains the [<modName>:]n string identifier
    //	and its index number in the tokenList.
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::list<std::pair<string,size_t> > ParamInfo;

    //## Constructors (generated)
      LinkExpression();

      LinkExpression(const LinkExpression &right);

    //## Destructor (generated)
      virtual ~LinkExpression();

    //## Assignment Operation (generated)
      LinkExpression & operator=(const LinkExpression &right);


    //## Other Operations (specified)
      //## Operation: init%391C0C0B01EA
      //	This can only perform the first stage of initialization
      //	since it has no information about actually existing
      //	Parameter objects (this class can't even know what a
      //	Parameter object is).  Once the higher level client
      //	class has determined which parameter strings are valid,
      //	it must perform the second stage of initialization by
      //	calling resetParamInfo.
      virtual void init (const string& exprString, bool removeWhitespace = true);

      //## Operation: clone%4851233D00A3
      virtual LinkExpression* clone () const;

      //## Operation: evaluate%4852BF3400F7
      Real evaluate (const RealArray& parVals) const;

      //## Operation: resetParamInfo%4857C9BC001C
      //	This performs the second stage of initialization and
      //	ultimately builds the postfix expression array.  The
      //	input array indicates which of the strings initially
      //	placed in m_parIDs are actually found to match up with
      //	existing Parameter objects.
      void resetParamInfo (const std::vector<bool>& isParFound);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: parIDs%4857CDF001BD
      //	Each pair contains the [<modName>:]n string identifier
      //	and its index number in the tokenList.
      const LinkExpression::ParamInfo& parIDs () const;

  public:
    // Additional Public Declarations
      //## begin LinkExpression%391B1A15016E.public preserve=yes
      //## end LinkExpression%391B1A15016E.public

  protected:

    //## Other Operations (specified)
      //## Operation: Swap%48511B3E001B
      void Swap (LinkExpression& right);

    // Additional Protected Declarations
      //## begin LinkExpression%391B1A15016E.protected preserve=yes
      //## end LinkExpression%391B1A15016E.protected

  private:

    //## Other Operations (specified)
      //## Operation: allValidChars%48512443006C
      virtual const string& allValidChars () const;

      //## Operation: convertToInfix%4851463A0391
      void convertToInfix ();

      //## Operation: convertToPostfix%4851463E03C1
      void convertToPostfix ();

      //## Operation: findParIDs%4857CE3A02A1
      void findParIDs ();

      //## Operation: verifyWordExprs%485B9F7B020F
      void verifyWordExprs (const std::vector<size_t>& numberedTokens) const;

      //## Operation: connectParsAndInts%485BF6DE02C8
      void connectParsAndInts (const std::vector<size_t>& numberTokens);

    // Additional Private Declarations
      //## begin LinkExpression%391B1A15016E.private preserve=yes
      //## end LinkExpression%391B1A15016E.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: allValidChars%485124B70158
      //	This allows some special chars since they may exist as
      //	part of a model name (though unlikely).
      //## begin LinkExpression::allValidChars%485124B70158.attr preserve=no  private: static string {UC} string(":_#.+-/*%!~()abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 \t\r\n")
      static const string s_allValidChars;
      //## end LinkExpression::allValidChars%485124B70158.attr

      //## Attribute: precedenceMap%4852C4D200A0
      //## begin LinkExpression::precedenceMap%4852C4D200A0.attr preserve=no  private: static std::map<string,int> {U} 
      static std::map<string,int> s_precedenceMap;
      //## end LinkExpression::precedenceMap%4852C4D200A0.attr

      //## Attribute: numericalConsts%4852C5BF02A4
      //## begin LinkExpression::numericalConsts%4852C5BF02A4.attr preserve=no  private: std::list<Real> {U} 
      std::list<Real> m_numericalConsts;
      //## end LinkExpression::numericalConsts%4852C5BF02A4.attr

      //## Attribute: mathOperators%4852C5EC00B8
      //	Originally to be filled in infix order, then rearranged
      //	to postfix before initialization is complete.
      //## begin LinkExpression::mathOperators%4852C5EC00B8.attr preserve=no  private: std::vector<string> {U} 
      std::vector<string> m_mathOperators;
      //## end LinkExpression::mathOperators%4852C5EC00B8.attr

      //## Attribute: postfixElems%4852C6A000E8
      //## begin LinkExpression::postfixElems%4852C6A000E8.attr preserve=no  private: std::vector<LinkExpression::ElementType> {U} 
      std::vector<LinkExpression::ElementType> m_postfixElems;
      //## end LinkExpression::postfixElems%4852C6A000E8.attr

      //## Attribute: infixElems%4852C78303A4
      //## begin LinkExpression::infixElems%4852C78303A4.attr preserve=no  private: std::vector<LinkExpression::ElementType> {U} 
      std::vector<LinkExpression::ElementType> m_infixElems;
      //## end LinkExpression::infixElems%4852C78303A4.attr

      //## begin LinkExpression::parIDs%4857CDF001BD.attr preserve=no  public: LinkExpression::ParamInfo {U} 
      LinkExpression::ParamInfo m_parIDs;
      //## end LinkExpression::parIDs%4857CDF001BD.attr

      //## Attribute: parToNum%485B9D91039E
      //	Private bookkeeping array used to match up elements in
      //	the parIDs list with their corresponding entry in the
      //	numericalConsts list, if any (and which indicates the
      //	need for removal from one or the other).  If no match,
      //	the value will be set to npos.
      //## begin LinkExpression::parToNum%485B9D91039E.attr preserve=no  private: std::vector<size_t> {U} 
      std::vector<size_t> m_parToNum;
      //## end LinkExpression::parToNum%485B9D91039E.attr

      //## Attribute: nonNumberTokens%486013CF00C3
      //	Private bookkeeping array, these are indices of tokens
      //	which are NOT detected to be parts of numerical
      //	constants as according to the AbstractExpression base
      //	class.  Therefore gaps in this sequence correspond to
      //	either genuine numerical constants OR parameter indices
      //	disguised as integers.
      //## begin LinkExpression::nonNumberTokens%486013CF00C3.attr preserve=no  private: std::vector<size_t> {U} 
      std::vector<size_t> m_nonNumberTokens;
      //## end LinkExpression::nonNumberTokens%486013CF00C3.attr

    // Additional Implementation Declarations
      //## begin LinkExpression%391B1A15016E.implementation preserve=yes
      //## end LinkExpression%391B1A15016E.implementation

};

//## begin LinkExpression%391B1A15016E.postscript preserve=yes
//## end LinkExpression%391B1A15016E.postscript

// Class LinkExpression::LinkExpressionError 

// Class LinkExpression 

//## Get and Set Operations for Class Attributes (inline)

inline const LinkExpression::ParamInfo& LinkExpression::parIDs () const
{
  //## begin LinkExpression::parIDs%4857CDF001BD.get preserve=no
  return m_parIDs;
  //## end LinkExpression::parIDs%4857CDF001BD.get
}

//## begin module%391C5AF200B8.epilog preserve=yes
//## end module%391C5AF200B8.epilog


#endif
